package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BasePriceType;
import com.ruoyi.web.base.service.IBasePriceTypeService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 价格类型 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-04
 */
@RestController
@RequestMapping("/base-price-type")
public class BasePriceTypeController {
    @Autowired
    private IBasePriceTypeService basePriceTypeService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("价格类型管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BasePriceType basePriceType, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (basePriceTypeService.count(new QueryWrapper<BasePriceType>().eq("org_id",loginOrgId).eq("price_type_num", basePriceType.getPriceTypeNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        basePriceType.setOrgId(loginOrgId);
        basePriceType.setCreateBy(getUsername());

        return success(basePriceTypeService.save(basePriceType));
    }

    @ApiOperation("价格类型管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BasePriceType basePriceType, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (basePriceTypeService.count(new QueryWrapper<BasePriceType>().ne("id",basePriceType.getId()).eq("org_id",loginOrgId).eq("price_type_num", basePriceType.getPriceTypeNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        basePriceType.setUpdateBy(getUsername());
        return success(basePriceTypeService.updateById(basePriceType));
    }

    @ApiOperation("价格类型管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            basePriceTypeService.removeById(s);
        }
        return success();
    }

    @ApiOperation("价格类型管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(basePriceTypeService.list(new QueryWrapper<BasePriceType>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("价格类型管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(basePriceTypeService.page(new Page<BasePriceType>(pageNum,pageSize),new QueryWrapper<BasePriceType>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("价格类型管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(basePriceTypeService.getById(id));
    }
}
